package object;

import java.awt.Color;
import java.awt.Graphics;

import stage.MainStage;
import densan.s.game.drawing.Drawer;
import densan.s.game.manager.GameManager;
import densan.s.game.object.GameObjectBase;
import densan.s.game.object.GameRectBase;

public class Ball extends GameObjectBase{
	 // サイズ
    private static final int SIZE = 5;
    
    // 速度
    private int vx, vy;


    public Ball(double x) {
    	//ラケットの真ん中
    	super(x-SIZE/2,Racket.Y-SIZE-1,SIZE,SIZE);

        // 速度を初期化（とりあえず固定）
        vx = 4;
        vy = -4;	
    }
    
    
    public void update(){
    	addX(vx);
    	addY(vy);
    	
    	// 左または右に当たったらx方向速度の符号を反転させる
        if (getX() < 0 || getX() > GameManager.getInstance().getFrameWidth() - getWidth()) {
        	vx = -vx;
        }
        
        // 上に当たったらy方向速度の符号を反転させる
        if (getY() < 0){
           vy = -vy;
        }
    }
    
    public void boundX(){
    	vx = -vx;
    }
    
    public void boundY(){
    	vy = -vy;
    }
    
    public void boundXY(){
    	vx = -vx;
    	vy = -vy;
    }
    
    public double getVx(){
    	return vx;
    }
    
    public double getVy(){
    	return vy;
    }
    
    //描画
    public void draw(Drawer d){
    	//穴埋めにする
    	d.setColor(Color.BLUE);
    	d.fillCircle((int)getX(), (int)getY(), (getHeight() + getWidth())/2);
    	
    	 // 枠線を描画
        d.setColor(Color.BLACK);
        d.drawCircle((int)getX(), (int)getY(), (getHeight() + getWidth())/2);
    }
    
}
