package object;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

import densan.s.game.drawing.Drawer;
import densan.s.game.object.GameRectBase;

public class Block extends GameRectBase{
	 public static final int WIDTH = 40;
	 public static final int HEIGHT = 16;
	 
	// ボールが当たって消されたか
	    public boolean isDead;
	    
	    
	 // ボールの当たり位置
	    public static final int NO_COLLISION = 0;
	    public static final int DOWN = 1;
	    public static final int LEFT = 2;
	    public static final int RIGHT = 3;
	    public static final int UP = 4;
	    

	public Block(double x, double y) {
		super(x, y, WIDTH, HEIGHT);
		//最初の状態ではブロックは消えていない
		isDead = false;
	}
	
	public void dead(){
		isDead = true;
	}
	
	
	public int collideWith(Ball ball) {
        Rectangle blockRect = new Rectangle((int)getX(), (int)getY(), WIDTH, HEIGHT);

        int ballX = (int)ball.getX();
        int ballY = (int)ball.getY();
        int ballSize = ball.getHeight();
        
        if (blockRect.contains(ballX, ballY)
            && blockRect.contains(ballX + ballSize, ballY)) {
            // ブロックの下から衝突＝ボールの左上・右上の点がブロック内
            return DOWN;
        } else if (blockRect.contains(ballX + ballSize, ballY)
            && blockRect.contains(ballX + ballSize, ballY + ballSize)) {
            // ブロックの左から衝突＝ボールの右上・右下の点がブロック内
            return LEFT;
        } else if (blockRect.contains(ballX, ballY)
            && blockRect.contains(ballX, ballY + ballSize)) {
            // ブロックの右から衝突＝ボールの左上・左下の点がブロック内
            return RIGHT;
        } else if (blockRect.contains(ballX, ballY + ballSize)
            && blockRect.contains(ballX + ballSize, ballY + ballSize)) {
            // ブロックの上から衝突＝ボールの左下・右下の点がブロック内
            return UP;
        }

        return NO_COLLISION;
    }
	
	
	
	public void draw(Drawer d) {
		//穴埋め
		
        d.setColor(Color.CYAN);
        d.fillRect((int)getX(), (int)getY(), getWidth(), getHeight());

        // 枠線を描画
        d.setColor(Color.BLACK);
        d.drawRect((int)getX(), (int)getY(), getWidth(), getHeight());
    }
	
}
